Subject: bug#38785: 26.3; `y-or-n-p' leaves prompt and response in echo area

From: Drew Adams <[email-masked]>
Date: Sun, 29 Dec 2019 06:08:07 -0800 (PST)

> > I think `y-or-n-p' should probably just use
> > `(sit-for 1)' after it shows the prompt + answer,
> 
> That would always delay the caller of y-or-n-p by one
> second.  I'm pretty sure that would be highly annoying.

1. Not always delay.  It's sit-for, not sleep-for,
   after all.  Have you tried it?  I haven't noticed
   a problem with it so far, but there are no doubt
   lots of possible use cases.

2. More annoying than the problem it aims to solve?

3. Alternative solutions are welcome.

The basic problem stems from `read-key' prompting
in the echo area.  That's really not ideal, at
least in some contexts.  (But making it read using
the minibuffer would be an even bigger mistake,
IMO.)